```
███████╗██╗   ██╗██████╗ ███████╗██████╗
██╔════╝██║   ██║██╔══██╗██╔════╝██╔══██╗
███████╗██║   ██║██████╔╝█████╗  ██████╔╝
╚════██║██║   ██║██╔═══╝ ██╔══╝  ██╔══██╗
███████║╚██████╔╝██║     ███████╗██║  ██║
╚══════╝ ╚═════╝ ╚═╝     ╚══════╝╚═╝  ╚═╝
██████╗  ██████╗ ██╗    ██╗███████╗██████╗ ███████╗
██╔══██╗██╔═══██╗██║    ██║██╔════╝██╔══██╗██╔════╝
██████╔╝██║   ██║██║ █╗ ██║█████╗  ██████╔╝███████╗
██╔═══╝ ██║   ██║██║███╗██║██╔══╝  ██╔══██╗╚════██║
██║     ╚██████╔╝╚███╔███╔╝███████╗██║  ██║███████║
╚═╝      ╚═════╝  ╚══╝╚══╝ ╚══════╝╚═╝  ╚═╝╚══════╝
```

### What is JCB Super Powers?
The Joomla Component Builder (JCB) Super Power features are designed to enhance JCB's functionality and streamline the development process. These Super Powers enable developers to efficiently manage and share their custom powers across multiple JCB instances through repositories hosted on [https://git.vdm.dev/[username]/[repository-name]](https://git.vdm.dev). JCB Super Powers are managed using a combination of layers, events, tasks, methods, switches, and algorithms, which work together to provide powerful customization and extensibility options. More details on JCB Super Powers can be found in the [Super Powers Documentation](https://git.vdm.dev/joomla/super-powers/wiki).

In summary, JCB Super Powers offer a flexible and efficient way to manage and share functionalities between JCB instances. By utilizing a sophisticated system of layers, events, tasks, methods, switches, and algorithms, developers can seamlessly integrate JCB core powers and their custom powers. For more information on how to work with JCB Super Powers, refer to the [Super Powers User Guide](https://git.vdm.dev/joomla/super-powers/wiki).

### What can I find here?
This repository contains an index (see below) of all the approved powers within the JCB GUI. During the compilation of a component, these powers are automatically added to the repository, ensuring a well-organized and accessible collection of functionalities.

# Index of powers

- **Namespace**: [VDM\Minify](#vdm-minify)

  - **class Css** | [Details](src/70530246-2903-4c02-af9a-61182e4d97b8) | [Code](src/70530246-2903-4c02-af9a-61182e4d97b8/code.php) | [Settings](src/70530246-2903-4c02-af9a-61182e4d97b8/settings.json) | [70530246-2903-4c02-af9a-61182e4d97b8](src/70530246-2903-4c02-af9a-61182e4d97b8)
  - **class JavaScript** | [Details](src/ef6438c4-76db-4aa1-bb15-bc97583bcd2e) | [Code](src/ef6438c4-76db-4aa1-bb15-bc97583bcd2e/code.php) | [Settings](src/ef6438c4-76db-4aa1-bb15-bc97583bcd2e/settings.json) | [ef6438c4-76db-4aa1-bb15-bc97583bcd2e](src/ef6438c4-76db-4aa1-bb15-bc97583bcd2e)
- **Namespace**: [VDM\Minify\Abstraction](#vdm-minify-abstraction)

  - **abstract class Minify** | [Details](src/d2b8599a-d5ce-49b1-b992-764bb7d55137) | [Code](src/d2b8599a-d5ce-49b1-b992-764bb7d55137/code.php) | [Settings](src/d2b8599a-d5ce-49b1-b992-764bb7d55137/settings.json) | [d2b8599a-d5ce-49b1-b992-764bb7d55137](src/d2b8599a-d5ce-49b1-b992-764bb7d55137)
- **Namespace**: [VDM\Minify\Path](#vdm-minify-path)

  - **class Converter** | [Details](src/39f8957f-cc73-4da5-8b60-6cf25d4ab058) | [Code](src/39f8957f-cc73-4da5-8b60-6cf25d4ab058/code.php) | [Settings](src/39f8957f-cc73-4da5-8b60-6cf25d4ab058/settings.json) | [39f8957f-cc73-4da5-8b60-6cf25d4ab058](src/39f8957f-cc73-4da5-8b60-6cf25d4ab058)
- **Namespace**: [VDM\Minify\Path\Interfaces](#vdm-minify-path-interfaces)

  - **interface ConverterInterface** | [Details](src/cc482882-5eef-476c-b835-7b0c5a17c0db) | [Code](src/cc482882-5eef-476c-b835-7b0c5a17c0db/code.php) | [Settings](src/cc482882-5eef-476c-b835-7b0c5a17c0db/settings.json) | [cc482882-5eef-476c-b835-7b0c5a17c0db](src/cc482882-5eef-476c-b835-7b0c5a17c0db)
- **Namespace**: [VDM\Joomla\Componentbuilder\Compiler\Utilities](#vdm-joomla-componentbuilder-compiler-utilities)

  - **abstract class Minify** | [Details](src/b591855d-d106-4fe5-90ad-8e706f6267cf) | [Code](src/b591855d-d106-4fe5-90ad-8e706f6267cf/code.php) | [Settings](src/b591855d-d106-4fe5-90ad-8e706f6267cf/settings.json) | [b591855d-d106-4fe5-90ad-8e706f6267cf](src/b591855d-d106-4fe5-90ad-8e706f6267cf)

# Class Diagrams

## VDM Minify
> namespace VDM\Minify
```uml
@startuml

namespace VDM\Minify #Azure {


  class Css  #Gold {
    # $maxImportSize
    + setMaxImportSize()
    + setImportExtensions()
    # moveImportsToTop() : string
    # combineImports() : string
    # importFiles() : string
    + execute() : string
    # move() : string
    # shortenColors() : string
    # shortenFontWeights() : string
    # shortenZeroes() : string
    # stripEmptyTags() : string
    # stripComments()
    # stripWhitespace() : string
    # extractMath()
    # extractCustomProperties()
    # canImportBySize() : bool
    # canImportByPath() : bool
    # getPathConverter() : ConverterInterface
  }

  class JavaScript  #Gold {
    # $keywordsReserved
    # $keywordsBefore
    # $keywordsAfter
    # $operatorsBefore
    + execute() : string
    # stripComments()
    # extractRegex()
    # stripWhitespace() : string
    # getOperatorsForRegex() : string[]
    # getKeywordsForRegex() : string[]
    # propertyNotation() : string
    # shortenBools() : string
  }
}


@enduml
```

## VDM Minify Abstraction
> namespace VDM\Minify\Abstraction
```uml
@startuml

namespace VDM\Minify\Abstraction #DarkCyan {


  abstract Minify  #Orange {
    # $data
    # $patterns
    + $extracted
    + __construct()
    + add() : static
    + addFile() : static
    + minify() : string
    + gzip() : string
    + cache() : CacheItemInterface
    + {abstract} execute() : string
    # load() : string
    # save()
    # registerPattern()
    # replace() : string
    # executeReplacement() : string
    # extractStrings()
    # restoreExtractedData() : string
    # canImportFile() : bool
    # openFileForWriting() : resource
    # writeToFile()
    # {static} str_replace_first()
  }
}


@enduml
```

## VDM Minify Path
> namespace VDM\Minify\Path
```uml
@startuml

namespace VDM\Minify\Path #DarkCyan {


  class Converter  #Gold {
    # $from
    # $to
    + __construct()
    # normalize() : string
    # shared() : string
    + convert() : string
    # dirname() : string
  }
}


@enduml
```

## VDM Minify Path Interfaces
> namespace VDM\Minify\Path\Interfaces
```uml
@startuml

namespace VDM\Minify\Path\Interfaces #Olive {


  interface ConverterInterface  #Lavender {
    + convert() : string
  }
}


@enduml
```

## VDM Joomla Componentbuilder Compiler Utilities
> namespace VDM\Joomla\Componentbuilder\Compiler\Utilities
```uml
@startuml

namespace VDM\Joomla\Componentbuilder\Compiler\Utilities #LightGreen {


  abstract Minify  #Orange {
    + {static} js() : string
    + {static} css() : string
  }
}


@enduml
```


---
```
     ██╗ ██████╗  ██████╗ ███╗   ███╗██╗      █████╗
     ██║██╔═══██╗██╔═══██╗████╗ ████║██║     ██╔══██╗
     ██║██║   ██║██║   ██║██╔████╔██║██║     ███████║
██   ██║██║   ██║██║   ██║██║╚██╔╝██║██║     ██╔══██║
╚█████╔╝╚██████╔╝╚██████╔╝██║ ╚═╝ ██║███████╗██║  ██║
 ╚════╝  ╚═════╝  ╚═════╝ ╚═╝     ╚═╝╚══════╝╚═╝  ╚═╝
 ██████╗ ██████╗ ███╗   ███╗██████╗  ██████╗ ███╗   ██╗███████╗███╗   ██╗████████╗
██╔════╝██╔═══██╗████╗ ████║██╔══██╗██╔═══██╗████╗  ██║██╔════╝████╗  ██║╚══██╔══╝
██║     ██║   ██║██╔████╔██║██████╔╝██║   ██║██╔██╗ ██║█████╗  ██╔██╗ ██║   ██║
██║     ██║   ██║██║╚██╔╝██║██╔═══╝ ██║   ██║██║╚██╗██║██╔══╝  ██║╚██╗██║   ██║
╚██████╗╚██████╔╝██║ ╚═╝ ██║██║     ╚██████╔╝██║ ╚████║███████╗██║ ╚████║   ██║
 ╚═════╝ ╚═════╝ ╚═╝     ╚═╝╚═╝      ╚═════╝ ╚═╝  ╚═══╝╚══════╝╚═╝  ╚═══╝   ╚═╝
██████╗ ██╗   ██╗██╗██╗     ██████╗ ███████╗██████╗
██╔══██╗██║   ██║██║██║     ██╔══██╗██╔════╝██╔══██╗
██████╔╝██║   ██║██║██║     ██║  ██║█████╗  ██████╔╝
██╔══██╗██║   ██║██║██║     ██║  ██║██╔══╝  ██╔══██╗
██████╔╝╚██████╔╝██║███████╗██████╔╝███████╗██║  ██║
╚═════╝  ╚═════╝ ╚═╝╚══════╝╚═════╝ ╚══════╝╚═╝  ╚═╝
```
> Build with [Joomla Component Builder](https://git.vdm.dev/joomla/Component-Builder)

